<template src="./template.html"></template>

<script lang="ts">
function sleep(milliseconds: number) {
  return new Promise((resolve, reject) => {
    setTimeout(() => {
      resolve(true);
    }, milliseconds);
  });
}
import { clone, cloneDeep } from "lodash";
import { Component, Prop, Vue, Watch } from "nuxt-property-decorator";
import { regexEmail } from "~/common/constaint";
import { apiErrorHandler } from "~/utils/apiHanlers";
var momentz = require("moment-timezone");
@Component({
  components: {},
})
export default class ManageSellersComponent extends Vue {
  @Prop()
  tab!: number;

  config = {
    page: 1,
    limit: 25,
    search: "",
    isActive: true,
  };
  page = 1;

  listStatus = [
    {
      title: "All",
      value: 0,
    },
    {
      title: "Active",
      value: 1,
    },
    {
      title: "Deactive",
      value: 2,
    },
  ];
  status = 0;

  dialogAddAdmin = false;
  dialogViewDetail = false;
  loading = false;
  loadingTable = false;

  seller = {
    email: "",
    password: "",
  };

  sellerDetail = {
    email: "",
    password: "",
    phoneNumber: "",
    name: "",
    supportEmail: "",
  };
  dateEndPicker = false;

  tip = 0;

  checkTip(evt: any) {
    evt = evt ? evt : window.event;
    let expect = evt.target.value.toString() + evt.key.toString();

    if (!/^[-+]?[0-9]*\.?[0-9]*$/.test(expect)) {
      evt.preventDefault();
    } else {
      return true;
    }
  }

  get timeActive() {
    return this.$store.state.setting.timeActive;
  }

  set timeActive(value: string) {
    this.$store.commit("setting/setTimeActive", value);
  }

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  disabledButtonDate = false;
  get listAdmin() {
    const listAdmin = cloneDeep(this.$store.state.masterUsers.listAdmin);
    return listAdmin || [];
  }

  get totalPage() {
    return this.$store.state.masterUsers.totalPage || 0;
  }

  get timezone() {
    return this.$store.state.setting.timezone;
  }

  loadingStats = false;
  stats = {};

  async onGetStats() {
    try {
      this.loadingStats = true;
      this.stats = {};
      const response = await this.$api.stats.statsByTimeMaser({
        ...this.config,
        from: this.from,
        to: this.to,
        timezone: this.timezone,
      });
      if (response?.data) {
        this.stats = response.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingStats = false;
    }
  }

  get dateArr() {
    return this.$store.state.setting?.dateArr || [];
  }

  set dateArr(value: string[]) {
    this.$store.commit("setting/setDateArr", value);
  }
  get dateRangeText() {
    return this.dateArr.join("~");
  }
  currentDate = "";
  onSearchByDate() {
    if (this.dateRangeText.split("~").length < 2) {
      return this.$pushNotification.error("Please select 2 days or date range");
    }
    this.$store.commit("setting/setTime", {
      dateStart: this.dateRangeText.split("~")[0],
      dateEnd: this.dateRangeText.split("~")[1],
    });

    this.onGetStats();
    this.timeActive = "";
  }

  onRefresh() {
    this.onFilterByTime("Today");
  }

  mounted() {
    this.onFilterByTime("Today");
    this.onGetListUser();
    this.getCurrentDate();
  }
  getCurrentDate() {
    this.currentDate = momentz
      .tz(this.timezone)
      .format("hh:mm A DD MMM YYYY, z Z");
  }
  async onFilterByTime(time: string) {
    this.$store.commit("setting/setFilterByTime", { time });
    this.disabledButtonDate = true;
    // await this.onGetStats();
    this.disabledButtonDate = false;
  }
  async onGetListUser() {
    try {
      this.loadingTable = true;
      const config = this.config;
      if (this.status === 1) {
        config["isActive"] = true;
      } else if (this.status === 2) {
        config["isActive"] = false;
      } else {
        //@ts-ignore
        delete this.config.isActive;
      }
      await this.$store.dispatch("masterUsers/onGetListAdmin", {
        ctx: this,
        query: this.config,
      });
    } catch (error) {
      console.log("error :>> ", error);
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  openDialogAddAdmin() {
    this.dialogAddAdmin = true;
    this.clearData();
  }

  closeDialogAddAdmin() {
    this.dialogAddAdmin = false;
  }

  async onAddAdmin() {
    try {
      if (!(this.seller.email || this.seller.password)) {
        return this.$pushNotification.error("Please enter full information");
      }
      if (!regexEmail.test(this.seller.email)) {
        return this.$pushNotification.error("Email invalid");
      }
      await this.$api.userMaster.createAdmin(this.seller);
      this.$pushNotification.success("Create a successful admin");
      this.clearData();
      this.dialogAddAdmin = false;
      this.onGetListUser();
    } catch (error) {
      console.log("error :>> ", error);
      apiErrorHandler(error, this);
    }
  }

  openDialogViewDetail(seller: any) {
    this.sellerDetail = seller;
    this.dialogViewDetail = true;
  }
  adminInfo: any = {};
  dialogConfirm = false;
  openDialogConfirm(admin: any) {
    if (admin) {
      this.adminInfo = admin;
      this.dialogConfirm = true;
    }
  }

  async closeDialogConfirm() {
    const findIndex = this.listAdmin.findIndex(
      (item: any) => item._id === this.adminInfo._id
    );
    this.loadingTable = true;
    this.listAdmin[findIndex].isActive = !this.listAdmin[findIndex].isActive;
    await sleep(10);
    this.loadingTable = false;
    this.dialogConfirm = false;
  }

  async onChangeStatus() {
    try {
      this.loading = true;
      await this.$api.userMaster.changeStatus({
        adminId: this.adminInfo._id,
        isActive: this.adminInfo.isActive,
      });
      this.$pushNotification.success("Change status successfully");
      this.onGetListUser();
      this.dialogConfirm = false;
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  clearData() {
    this.seller = {
      email: "",
      password: "",
    };
  }

  onRedirectPage() {
    this.config.page = this.page;
    this.onGetListUser();
  }

  @Watch("config.page")
  changedPage() {
    this.onGetListUser();
  }

  @Watch("tab")
  changeTab(value: number) {
    if (value === 0) {
      this.onGetListUser();
    }
  }
}
</script>

<style scoped lang="scss">
.form-resp {
  @media (max-width: 600px) {
    width: 100% !important;
  }
}
</style>
